# Hebern1Rot.py : une machine a chiffrer avec un rotor
# mais il y a deux stators: clavier et lampe
# on peut inverser le rotor, utiliser le mode chiffre/dechiff
# et specifier la clef de messages (la position init du rotor

import string
import sys
from ROTOR import *

ALPHA = string.ascii_uppercase
N = 26
# ===================================
def is_maj(car):
    if ALPHA.find(car) == -1: 
        return 0
    else:
        return 1
# ==================================
def litfic( fic ):
    f = open(fic,"r")
    leTexte = f.readlines()
    texteConcat = ""
    f.close()
    for i in range(len(leTexte)):
        ch = leTexte[i]
        ch = ch.upper()
        for j in range(len(ch)):
            if not is_maj(ch[j]):
                continue
            texteConcat = texteConcat + ch[j]
    return texteConcat
# =====================================
# ================================================
class HEBERN:
    def __init__(self, \
            pi_rotor=ALPHA, \
            pi_keyboard=ALPHA, \
            pi_lampboard=ALPHA, \
            mode_cipher=True, \
            trigo=False, \
            rim=False, \
            reverse=False, \
            debug=False):
        self.mode_cipher = mode_cipher
        self.Trigo = trigo
        self.Rim = rim
        self.Reverse = reverse
        self.Rotor      = Rotor(pi_rotor, self.Trigo, self.Rim, self.Reverse )
        self.StatorKeyb = Rotor(pi_keyboard)
        self.StatorKeyb.zero()
        self.StatorLamp = Rotor(pi_lampboard)
        self.StatorLamp.zero()
        self.DEBUG = debug
        self.DontMove = False

    def info(self):
        ch = ""
        ch += "Cle: " + self.Rotor.get_external_key()  + "\n"
        """
        ch += "Cle: " + ALPHA[ self.Rotor.get_key() ] + "\n"
        ch += "Cipher Mode (False:decipher):" + str(self.mode_cipher) + "\n"
        ch += "Trigo (False:Clockwise, True:Trigo):"+ str(self.Trigo)+ "\n"
        ch += "Don't move : " + str(self.DontMove) + "\n"
        ch += "Key Stator : " + Rotor.rotor2char(self.StatorKeyb.PI) + "\n"
        ch += "Rotor      : " + Rotor.rotor2char(self.Rotor.PI) + "\n"
        ch += "Lamp Stator: " + Rotor.rotor2char(self.StatorLamp.PI) + "\n"
        ch += "Shifts     : " + str(self.Rotor.SHIFT) + "\n"
        ch += "Inv. shifts: " + str(self.Rotor.SHIFT_INV) + "\n"
        """
        ch = self.Rotor.info()
        return ch
        
    def toogleCipherMode(self):
        if self.cipher_mode: self.cipher_mode = False
        else: self.cipher_mode = True
        
    def toogleTrigoMode(self):
        if self.Trigo: 
            self.Trigo = False
        else: 
            self.Trigo = True
        self.Rotor.TRIGO = self.Trigo
        
    def toogleDontMove(self):
        if self.DontMove: self.DontMove = False
        else: self.DontMove = True

    def move(self):
        if not self.DontMove:
            self.Rotor.move_forward()
        if self.DEBUG:
            print("(%c) " % (self.Rotor.get_external_key()), end=":")
        
    def cipher_a_char(self, car):
        self.move()
        lettre_clair = ALPHA.index( car.upper())
        x = self.StatorKeyb.cipher_a_char(lettre_clair)
        y = self.Rotor.cipher_a_char( x )
        z = self.StatorLamp.cipher_a_char( y )
        new_car = ALPHA[ z ]
        if self.DEBUG:
            print(car, ALPHA[x], ALPHA[y], new_car)
        return new_car
        
    def decipher_a_char(self, car):
        self.move()
        lettre_clair = ALPHA.index( car.upper())
        x = self.StatorLamp.decipher_a_char(lettre_clair)
        y = self.Rotor.decipher_a_char( x )
        z = self.StatorKeyb.decipher_a_char( y )
        new_car = ALPHA[ z ]
        if self.DEBUG:
            print(car, ALPHA[x], ALPHA[y], new_car)
        return new_car
#========================================================================
if __name__ == "__main__" :
    h = HEBERN("OBCLJATDIUZXSWRHNYEVMGKFQP")
    clair = "ILFAITBEAU"
    h.Rotor.rewind()
    print(h.info())
    crypto = ""
    for c in clair:
        crypto += h.cipher_a_char( c )
    print("Plain : ", clair)
    print("Crypto: ", crypto)
    print("Key   : ", ALPHA[h.Rotor.get_key()])

    h.toogleTrigoMode()
    h.Rotor.rewind()
    print(h.info())
    crypto = ""
    for c in clair:
        crypto += h.cipher_a_char( c )
    print("Crypto : ", crypto )
    print("Key   : ", ALPHA[h.Rotor.get_key()])

    h = HEBERN("FTQJVAXMWDSNHLRUCOKBPEIGZY")
    h.Rotor.set_external_key("D")
    print(h.info())

