# DEUXROT.py : une machine a chiffrer avec deux rotors
# UN_ROT.py


import string
import sys
ALPHA = string.ascii_uppercase
# ===================================
def is_maj(car):
    if car in ALPHA:
        return True
    else:
        return False
# ==================================
def litfic( fic ):
    f = open(fic,"r")
    leTexte = f.readlines()
    texteConcat = ""
    f.close()
    for i in range(len(leTexte)):
        ch = leTexte[i]
        ch = ch.upper()
        for j in range(len(ch)):
            if not is_maj(ch[j]):
                continue
            texteConcat = texteConcat + ch[j]
    return texteConcat
# =====================================
class ROTOR:
    def __init__(self, alpha):
        self.Index = 0
        self.Decal = []
        self.Decal_inv = []
        PI = alpha
        for i in range(26):
            j = ALPHA.index( PI[i] )
            self.Decal.append( (j - i + 26) % 26 )
        tampon = list(range(26))
        for i in range(26):
            j = ALPHA.index( PI[i] )
            tampon[j] = i
        for i in range(26):
            self.Decal_inv.append( (tampon[i] - i + 26)%26 )
            
    def chiffre(self, lettre ):
        return (lettre + self.Decal[ (lettre + self.Index)%26 ])%26

    def dechiffre(self, lettre ):
        return (lettre + self.Decal_inv[ (lettre + self.Index)%26 ])%26

    def avance(self):
        self.Index = (self.Index + 1)%26

    def recule(self):
        self.Index = (self.Index - 1 + 26)%26

    def rewind(self):
        self.Index = 0
# ================================================
class HEBERN:
    def __init__(self,  alpha1, mode):
        # dans cette version alpha1 est un stator et alpha2 est un ROTOR
        self.Index = 0
        self.Mode = mode
        self.ROT = ROTOR(alpha1)
        
    def mise_a_la_cle(self, r1 ):
        self.rewind()
        indx_r1 = string.index(string.ascii_uppercase, r1.upper() )
        for i in range( indx_r1 ): self.ROT.avance()
        
    def avance(self):
        #if self.Index >= 26:
        #    self.Index = 0
        #    self.R1.avance()
        #else:
        #    self.Index = self.Index + 1
        self.ROT.avance()
        
    def toogleMode(self):
        if self.Mode == 0: self.Mode = 1
        else: self.Mode = 0
        
    def chiffre_un_car(self, car):
        self.avance()
        lettre_clair = ALPHA.index( car.upper() )
        y = self.ROT.chiffre(lettre_clair)
        new_car = string.ascii_uppercase[ y ]
        return new_car
        
    def dechiffre_un_car(self, car):
        self.avance()
        lettre_clair = ALPHA.index( car.upper() )
        y = self.ROT.dechiffre(lettre_clair)
        new_car = string.ascii_uppercase[ y ]
        return new_car
        
    def chiffre(self, texte ):
        ch = ""
        for i in range( len(texte) ):
            if self.Mode :
                c = self.chiffre_un_car( texte[i] )
            else:
                c = self.dechiffre_un_car( texte[i] )
            ch += c
        return ch
        
    def rewind(self):
        self.Index = 0
        self.ROT.rewind()
        
#========================================================================
if __name__ == "__main__" :
    h = HEBERN("TXNGDJBLYCFRSAUMWKEHQIPVZO", 0)
        
    clair = "ILFAITBEAUCEMATIN"
    crypto = h.chiffre( clair )
    print("Crypto: ", crypto)
    h.rewind()
    h.toogleMode()
    clair2 = h.chiffre( crypto )
    print("Clair:", clair2)
    
    
