# fried_new.py
# obj: 
#   La methode des intervalle utilisee a ete invente
#   par W.F. Friedman pour casser la Hebern 5.
#   Ce programme presente la version v2 de cette
#   methode.

import sys
import string
import getopt

ALPHA = string.ascii_uppercase
#LAMP  = "TYOEUMXDFJQVKWBNSHCILRZAGP"
N = 26
#======================================
def lit_stdin():
    entree = ""
    leTexte = sys.stdin.readlines()
    for i in range(len(leTexte)):
        entree += leTexte[i]
    flux_entre = ""
    for car in entree:
        if car.upper() in ALPHA or car.upper() == '?':
            flux_entre += car.upper()
    return flux_entre
#======================================
def usage():
    print("usage:")
    print("Syntax : motprobable.py [options...]")
    print("Example: echo AAAAA | python friedman.py -I 5 ")
    print("Options:")
    print("  -I interval Interval (4 by default)")
    print("              Interval 4:  01234 : X...Y")
    print("  -K key      The External Key (A by default)")

#======================================
try:
  if len(sys.argv) < 1:
    raise getopt.GetoptError("too few arguments")
  opts, args = getopt.getopt(sys.argv[1:],
    "hI:K:", ["help","interval=", "key="])
except getopt.GetoptError as err:
  # print help information and exit:
  print(sys.argv[0],": ", str(err))# option -a not recognized"
  usage()
  sys.exit(2)

DEBUG = False
KEY = 'A'
INTERVAL = 4
LAMP = ALPHA

for o, a in opts:
  if   o in ("-D", "--debug"):
    DEBUG = True
  elif o in ("-h", "--help"):
    usage()
    sys.exit()
  elif o in ("-K", "--key"):
    if a in ALPHA:
        KEY = a
  elif o in ("-I", "--interval"):
    if a.isnumeric():
        INTERVAL = int(a) 
  else:
    assert False, "unhandled option"

#--------------------------------------
CRYPTO = lit_stdin()
Z = len(CRYPTO)
DEBUT = ALPHA.find(KEY)
i = DEBUT
STATS = []
tb = [0]*N
for k in range(N):
    STATS.append(list(tb))
while i < Z:
    j = i

    for k in range(j,j+26):
        m = (k + INTERVAL)
        if m >= (j+N): m -= N
        if m >= Z: break        
        if CRYPTO[k] == '?' or CRYPTO[m] == '?':
            continue
        let1 = ALPHA.find(CRYPTO[k])
        let2 = ALPHA.find(CRYPTO[m])
        let1bis = (let1 + k) % N
        let2bis = (let2 + INTERVAL + k) % N
        print("k,m,cry[k],cry[m]", k,m, ALPHA[let1], ALPHA[let2], end=" : ")
        print("k,m,cry[k],cry[m]", k,m, ALPHA[let1bis], ALPHA[let2bis])
        STATS[let1bis][let2bis] += 1
    # ------- on passe a la suite
    print(CRYPTO[i:i+N])
    i += N
print("   ", end="")
for i in range(N):
    print("%2c" % (ALPHA[i]), end=" ")
print()
for i in range(N):
    print("%c:" % (ALPHA[i]), end="")
    for j in range(N):
        print("%3d" % (STATS[j][i]), end="")
    print()

TOTAL = list(tb)
for i in range(N):
    for j in range(N):
        TOTAL[i] += STATS[i][j]
print("  ", end="")
for i in range(N):
    print("%3d" % (TOTAL[i]), end="")
print()
