# hebern1_tui.py 
# obj: a Hebern cipher machine (Only one Rotor) with TUI 
#      (Text User Interface)
# ----- a faire
# * mai 2023: passage a PY3 et on lit des fichiers rotors
# * mai 2023: afficher les decalages !!!!
# + jun 2023: on passe en anglais et on fait un readme et un tar
# + jul 2023: etre sur du fonctionnement (à croiser avec H5 qui est juste(je crois)
# +           notamment la direction 
# + jul 2023: ajouter la possibilité de mettre wiring en option
# + dec 2023: ajouter le RIM (le pourtour du rotor different de la direct 
#             (Clockwise ou Trigonometric)

import sys
from Hebern1Rot import *
import string
import getopt

#======================================
def lit_rotor(nom):
    f = open("ROTORS/" + nom + ".rot")
    permutation = f.readline()
    f.close()
    return permutation.strip()    
#======================================
def lit_stdin():
    entree = ""
    leTexte = sys.stdin.readlines()
    for i in range(len(leTexte)):
        entree += leTexte[i]
    flux_entre = ""
    for car in entree:
        if car.upper() in ALPHA:
            flux_entre += car.upper()
    return flux_entre
#======================================
def usage():
    print("usage:")
    print("Syntax : hebern1_tui.py [options...]")
    print("Example: echo AAAAA | python hebern1_tui.py -R c1 ")
    print("Options:")
    print("  -L lamp     The lampboard permutation (iden by defaults)")
    print("  -K keyb     The keyboard permutation (iden by defaults)")
    print("  -R rotor    The rotor (iden  by defaults)")
    print("  -E external The external key (Z by default)")
    print("  -d          Decipher Mode (cipher mode by default)")
    print("  -t          Trigonometric direction (False [clockwise] by default)")
    print("  -T          The Rim is different from direction (False by default)")
    print("  -m          Dont Move (0 by default)")
    print("  -r          Reverse the Rotor (mirror)")
    print("  -D          Debug Mode")
    print("Note: for L,K,R options, if you begins with =, the wiring is")
    print("given, otherwise, you must give a file which contains the wiring")
    print("the filename is given without the .rot extension and it must")
    print("be in the ROTORS/ directory.") 
    print("Note: iden = identity permutation = ABC...Z")

#======================================
try:
  if len(sys.argv) == 0:
    raise getopt.GetoptError("too few arguments")
  opts, args = getopt.getopt(sys.argv[1:],
    "hL:K:R:E:rDdtTm", ["help","lamp=","keyb=","rotor=",
    "external=", "reverse", "debug", "decipher", "trigo", "rim", "move" ])
except getopt.GetoptError as err:
  # print help information and exit:
  print(sys.argv[0],": ", str(err))# option -a not recognized"
  usage()
  sys.exit(2)

DEBUG = False
REVERSE = False
CIPHER_MODE = True
TRIGO_MODE = False
RIM = False
DONT_MOVE = False
KEYEXTERN = None
STATORKEY = string.ascii_uppercase 
ROTOR     = string.ascii_uppercase 
STATORLAMP= string.ascii_uppercase 

for o, a in opts:
  if   o in ("-D", "--debug"):
    DEBUG = True
  elif o in ("-h", "--help"):
    usage()
    sys.exit()
  elif o in ("-L", "--lamp"):
    if a[0] == "=":
        STATORLAMP = a[1:]
    else:
        STATORLAMP = lit_rotor(a)
  elif o in ("-K", "--keyb"):
    if a[0] == "=":
        STATORKEY = a[1:]
    else:
        STATORKEY = lit_rotor(a)
  elif o in ("-R", "--rotor"):
    if a[0] == "=":
        ROTOR = a[1:]
    else:
        ROTOR = lit_rotor(a)
  elif o in ("-E", "--external="):
    KEYEXTERN = a.upper()
  elif o in ("-d", "--decipher"):
    CIPHER_MODE = False
  elif o in ("-t", "--trigo"):
    TRIGO_MODE = True
  elif o in ("-T", "--rim"):
    RIM = True
  elif o in ("-m", "--move"):
    DONT_MOVE = True
  elif o in ("-r", "--reverse"):
    REVERSE = True
  else:
    assert False, "unhandled option"

#--------------------------------------
c = HEBERN( ROTOR, STATORKEY,STATORLAMP,CIPHER_MODE,TRIGO_MODE,RIM,REVERSE,DEBUG)
if KEYEXTERN is not None:
    c.Rotor.set_external_key(KEYEXTERN)
if DONT_MOVE:
    c.toogleDontMove()
if DEBUG : 
    print(c.info())

plain = lit_stdin()
crypto = "" 
n = 0
idx = 1

if DEBUG:
    if CIPHER_MODE:
        print("----  (K) :P K R L  (Key), Plain, Keyboard, Rotor, Lampboard [cipher]")
    else:
        print("----  (K) :C l r k  (Key), Cipher,Lamp -1, Rotor -1, Keyb -1 [plain]")
for i in range(len(plain)):
    car = plain[i]
    if DEBUG:
        print("%04d: " % (idx),  end="")
    idx += 1
    if CIPHER_MODE:
        car = c.cipher_a_char(car)
    else:
        car = c.decipher_a_char(car)
    crypto = crypto + car
    n += 1
print(crypto)

