# num_alpha.py
# Displays PHI for a variable number of alphabets from 1 to N

import sys
import string

ALPHA = string.ascii_uppercase
MAX  = 5000
CRYPTO = [0]*MAX
N = 26
M = 10
LG = -1

#--------------------------------------------
def phi(tb):
    """ """ 
    total = 0
    for i in range(N):
        if tb[i] > 1:
            total += tb[i] * (tb[i] - 1)
    return total 

#--------------------------------------------
def lecture(nom):
    """ """
    global LG
    f = open(nom)    
    ch = f.read()
    if len(ch) >= MAX:
        print("Cryptogram too long")
        sys.exit(0)
    i = 0
    for c in ch:
        k = ALPHA.find(c.upper())
        if k >= 0: 
            CRYPTO[i] = k
            i += 1
    LG = i

# 1. Recuperer le cryptogramme et le nombre max d'alphabets.
try:
    nom_du_crypto = sys.argv[1]
    if len(sys.argv) > 2:
        M = int(sys.argv[2])
    else:
        M = 10
    lecture(nom_du_crypto)
except:
    print("Syntaxe: ", sys.argv[0], " cryptogram [number_of_alphabets]")
    print("   by default , ", M, " alphabets")
    sys.exit(1)

# 2. La grande boucle sur le nombre d'alphabets
tb = [0]*N
print("Number of letters: ", LG)
print("    Columns Phi     E(Phi_r)    E(Phi_p)")
for i in range(1,M+1):
    print("=====>%2d"%(i), end="")
    table = []
    tf = list(tb)
    for k in range(i):
        table.append(list(tb))

    # 2.1 Remplir le tableau
    for j in range(LG):
        x = j % i
        y = CRYPTO[j]
        table[x][y] += 1
        tf[y] += 1

    # 2.2 Calculer la moyenne
    total = 0
    for j in range(i):
        #print(j, phi(table[j]))
        total += phi(table[j])
    moy = total / i
    print("%10.1f"%(moy), end="")

    # 2.3 Esperances (random, non-random)
    lg = LG
    epr = 0.0385 * lg * (lg - 1) / (i*i)
    epp = 0.0683 * lg * (lg - 1) / (i*i)
    print("%10.1f  %10.1f" % (epr,epp))

