# phi.py
# Author: JF Bouchaudy, 7/2023
# This software calculates PHI to know if we have a simple
# substitution or not. It prints the frequencies of letters too.

import sys
import string

#---- GLOBAL VARIABLES ---------------------
ALPHA = string.ascii_uppercase
LG = -1
N = 26
FREQ = list([0]*N)
MAX = 5000
CRYPTO = [0]*MAX

#--------------------------------------------
def calculate_frequencies():
    for i in range(LG):
        letter = CRYPTO[i]
        FREQ[letter] += 1
#--------------------------------------------
def calculate_phi(tb):
    """ """ 
    total = 0
    for i in range(N):
        if tb[i] > 1:
            total += tb[i] * (tb[i] - 1)
    return total 

#--------------------------------------------
def lecture():
    """ """
    global LG
    nom = input("File name ? ")
    try:
        f = open(nom)    
        ch = f.read()
        if len(ch) >= MAX:
            print("ERROR: Cryptogram too long")
            sys.exit(0)
        f.close()
    except:
        print("ERROR: Impossible to open cryptogram file")
        return
    else:
        i = 0
        for c in ch:
            k = ALPHA.find(c.upper())
            if k >= 0: 
                CRYPTO[i] = k
                i += 1
        LG = i
#--------------------------------------------
lecture()
calculate_frequencies()
for i in range(0,N,7):
    for j in range(i,i+7):
        if j >= N: break
        print("%3c %3d"%(ALPHA[j],FREQ[j]), end=" ,")
    print()
print()
print("Letters: ", LG)
epr = int(0.0385 * LG * (LG-1))
epp = int(0.0684 * LG * (LG-1))
phi = calculate_phi(FREQ)
print("Phi values: ")
print("     Observed    = %10d" % (phi))
print("     Random      = %10d" % (epr))
print("     Non-random  = %10d" % (epp))

