# tb_pln_cry: 
# create an array from plain text and cryptogram

import sys
import string

# ------- Global variables ---------
N = 26
ALPHA = string.ascii_uppercase
PLAIN = ""
CRYPTO = ""
KEY =  0
tb = [-1] * N
TABLE = []
KEY_ORD = [None] * N
TB_ORD = {}
for i in range(N):
    TABLE.append( list(tb) )
    TB_ORD[ ALPHA[i] ] = list(tb) 
CHIFFRE = True

#-----------------------------------
def menu():
    """ """
    print("1 - Print cryptogram and plain text")
    print("2 - Choose the key (Z by default)")
    print("3 - Create generatrix")
    print("4 - Print generatrix")
    print("5 - Change mode (cipher or decipher [by default])")
    print("6 - Print ordered array")
    print("7 - Permute two columns of the ordered array")
    print("8 - Permute all columns of the ordered array")
    print("9 - Search columns fit")
    print("99- Quit")
#-----------------------------------
def search_fit():
    # --- on scan les colonnes
    print("Note: don't use the ordered table")
    for i in range(N):
        # --- on essaye s'apparier 2 colonnes
        for j in range(i+1,N):
            # --- on cree un dico pour enreg les diag
            #     et on cree une variable qui indique que c'est OK
            dico_left = {}
            dico_right = {}
            OK = True
            affiche = False
            cmpt = 0
            # --- on analyse les diagonales
            for k in range(N):
                # --- on cree une diagonale
                let1 = TABLE[k][i]
                let2 = TABLE[(k-1)%N][j]
                if let1 == -1 or let2 == -1:
                     continue
                if let1 == let2:
                     OK = False
                     break
                une_diag = let1+let2
                if let1 in dico_left:
                    if dico_left[let1] != une_diag:
                        OK = False
                        break
                else:
                    dico_left[let1] = une_diag
                if let2 in dico_right:
                    if dico_right[let2] != une_diag:
                        OK = False
                        break
                else:
                    dico_right[let2] = une_diag
                cmpt += 1
            # --- si OK, on affiche la colonne
            if OK and cmpt > 3:
                print(ALPHA[i] + "-" + ALPHA[j], "(%d)" % (cmpt), end=", ")
                affiche = True
        #if affiche: print()
        print()
    return     
#-----------------------------------
def print_cry_pln():
    """ """
    print("Lg: ", len(PLAIN))
    print("   ", end="")
    for i in range(N):
        print(" %c " % (ALPHA[i]), end="")
    print()
    print("---" * N)
    k = 0 ; m = 0
    for i in range(0,len(PLAIN),N):
        print("   ", end="")
        if i == 0 and KEY != 0:
            for j in range(KEY):
                print("   ", end="")
            for j in range(N-KEY):
                if k >= len(PLAIN):
                    break
                plain_letter = PLAIN[k]
                k += 1
                print(" %c " % (plain_letter), end="")
            print()
            
            print("   ", end="")
            for j in range(KEY):
                print("   ", end="")
            for j in range(N-KEY):
                if m >= len(CRYPTO):
                    break
                crypto_letter = CRYPTO[m]
                m += 1
                print(" %c " % (crypto_letter), end="")
            print()
            print()
            continue
            
        for j in range(N):
            if k >= len(PLAIN):
                break
            plain_letter = PLAIN[k]
            k += 1
            print(" %c " % (plain_letter), end="")
        print()
        print("   ", end="")
        for j in range(N):
            if m >= len(CRYPTO):
                break
            crypto_letter = CRYPTO[m]
            m += 1
            print(" %c " % (crypto_letter), end="")
        print()
        print()
    print()
#-----------------------------------
def filtre(ch):
    result = ""
    for c in ch:
        if c.upper() in ALPHA:
            result += c.upper()
    return result
#-----------------------------------
def reset_table():
    """ """
    for i in range(N):
        for j in range(N):
            TABLE[i][j] = -1
        TB_ORD[ ALPHA[i] ] = list(tb)
    KEY_ORD = [None] * N
#-----------------------------------
def create_generatrix():
    """ Construction of the array """
    lg_cry = len(CRYPTO)
    lg_pln = len(PLAIN)
    LG = lg_cry if lg_cry < lg_pln else lg_pln

    reset_table()
    if not CHIFFRE:
        abscisse = CRYPTO
        ordonnee = PLAIN
    else:
        abscisse = PLAIN
        ordonnee = CRYPTO
    for i in range(LG):
        row = (i + KEY)% N
        col = ALPHA.index(abscisse[i])
        contenu = ALPHA.index(ordonnee[i])
        if TABLE[row][col] == -1:
            TABLE[row][col] = contenu
    for i in range(N):
        KEY_ORD[i] = ALPHA[i]
        for j in range(N):
            TB_ORD[ ALPHA[i] ][j] = TABLE[j][i]

#-----------------------------------
def print_generatrix():
    """ Print the generatrix (row array) """
    invm = "Crypto" if CHIFFRE else "Plain"
    mode = "Plain"  if CHIFFRE else "Crypto"
    print("The Rotor Generatrix Tableau. Key: ", ALPHA[(KEY-1)%N])
    print("Coord of ", invm, " : Abscissa: ", mode, " , ordinate: Position of rotor")
    print("   ", end="")
    for i in range(N):
        print(" %c " % (ALPHA[i]), end="")
    print()
    for i in range(N):
        print(" %c-" % (ALPHA[i]), end="")
        for j in range(N):
            if TABLE[i][j] == -1:
                print("   ", end="")
            else:
                print(" %c " % (ALPHA[TABLE[i][j]]), end="")
        print()

#-----------------------------------
def cherche_key(cle):
    """ """
    for i in range(N):
        if KEY_ORD[i] == cle:
            return i
    return -1
#-----------------------------------
def permute():
    """ """
    ch = input("Columns to permute (return to exit)  ? (x,y) ")
    if ch == "": return
    x,y = ch.split(",")
    idx = cherche_key(x)
    idy = cherche_key(y)
    if idx == -1 or idy == -1:
        print("ERROR: Key not found ???")
        return
    KEY_ORD[idx] = y
    KEY_ORD[idy] = x

#-----------------------------------
def permute_all():
    """ """
    ch = input("Permutation alphabet (return to exit) ? ")
    if ch == "": return
    if len(ch) != N : 
        print("ERROR: length of the alphabet must be ", N, " long.")
        return
    if "".join(sorted(ch)) != ALPHA:
        print("ERROR: not all letters was used")
        return 

    for i in range(N):
        KEY_ORD[i] = ch[i]
    print("Permutation made...")
#-----------------------------------
def print_tb_ord():
    """ """
    for i in range(N):
        print(" %c " % (KEY_ORD[i]), end="")
    print()
    print("---" * N )
    for i in range(N):
        for j in range(N):
            #value = TB_ORD[ ALPHA[j] ][KEY_ORD[i]]
            value = TB_ORD[ KEY_ORD[j]][i]
            if value == -1:
                print("   ", end="")
            else:
                print(" %c " % (ALPHA[ value ]), end="")
        print()

#-----------------------------------
def change_key():
    global KEY

    print("Current value of the key: ", ALPHA[(KEY-1)%N])
    ch = input("New value (return to keep the current value) ? ")
    if ch == "": return
    if ch not in ALPHA: return
    val = ALPHA.index( ch )
    if val != -1:
        KEY = (val + 1)%N
        print("New value of the key: ", ALPHA[(KEY-1)%N])
#-----------------------------------
def change_mode():
    global CHIFFRE

    print("Current value of the mode: ", end="")
    if CHIFFRE: print(" Cipher(C)")
    else: print(" Decipher(D)")

    ch = input("New value (return to keep the current value) [C/D] ? ")
    if ch == "": return
    if ch == "C": CHIFFRE = True
    elif ch == "D": CHIFFRE = False
    print("New value of the mode: ", end="")
    if CHIFFRE: print(" Cipher(C)")
    else: print(" Decipher(D)")
    print("...Now, you need to generate again the generatrix!")
#-----------------------------------

# 1. Read files
if len(sys.argv) < 3:
    print("Syntaxe: cryptogram plain_text")
    sys.exit(1)

try:
    f = open(sys.argv[1])
    ch = f.read()
    CRYPTO = filtre(ch)
    f.close()
    f = open(sys.argv[2])
    ch = f.read()
    PLAIN = filtre(ch)
    f.close()
except:
    print("ERROR: impossible to read input files")
    sys.exit(1)

# ===== Big Loop
menu()
while True:
    ch = input("Choice ? ")
    if   ch == "":
        menu()
    elif ch == "99":
        break
    elif ch == "1":
        print_cry_pln()
    elif ch == "2":
        change_key()
    elif ch == "3":
        create_generatrix()
    elif ch == "4":
        print_generatrix() 
    elif ch == "5":
        change_mode()
    elif ch == "6":
        print_tb_ord()
    elif ch == "7":
        permute()
    elif ch == "8":
        permute_all()
    elif ch == "9":
        search_fit()
